<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: spatial_filtering_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_92d89ec45d405da5484bb10cba76683e.html">image_transforms</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">spatial_filtering_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2006  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_SPATIAL_FILTERINg_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_SPATIAL_FILTERINg_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../pixel.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../image_processing/generic_image.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;{</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="keyword">typename</span> in_image_type,</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keyword">typename</span> out_image_type,</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keyword">typename</span> EXP,</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        &gt;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    rectangle spatially_filter_image (</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="keyword">const</span> in_image_type&amp; in_img,</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        out_image_type&amp; out_img,</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP&gt;&amp; filter,</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        T scale = 1,</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <span class="keywordtype">bool</span> use_abs = <span class="keyword">false</span>,</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="keywordtype">bool</span> add_to = <span class="keyword">false</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    );</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keyword">typename</span> in_image_type,</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keyword">typename</span> out_image_type,</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keyword">typename</span> EXP1,</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        <span class="keyword">typename</span> EXP2,</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        &gt;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    rectangle spatially_filter_image_separable (</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keyword">const</span> in_image_type&amp; in_img,</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        out_image_type&amp; out_img,</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP1&gt;&amp; row_filter,</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP2&gt;&amp; col_filter,</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        T scale = 1,</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keywordtype">bool</span> use_abs = <span class="keyword">false</span>,</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        <span class="keywordtype">bool</span> add_to = <span class="keyword">false</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    );</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160; </div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="keyword">typename</span> in_image_type,</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keyword">typename</span> out_image_type,</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keyword">typename</span> EXP1,</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <span class="keyword">typename</span> EXP2</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        &gt;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    rectangle float_spatially_filter_image_separable (</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="keyword">const</span> in_image_type&amp; in_img,</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        out_image_type&amp; out_img,</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP1&gt;&amp; row_filter,</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP2&gt;&amp; col_filter,</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        out_image_type&amp; scratch,</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        <span class="keywordtype">bool</span> add_to = <span class="keyword">false</span></div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    );</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160; </div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        <span class="keyword">typename</span> in_image_type,</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        <span class="keyword">typename</span> out_image_type,</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keyword">typename</span> EXP1,</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        <span class="keyword">typename</span> EXP2,</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        &gt;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    rectangle spatially_filter_image_separable_down (</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> downsample,</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        <span class="keyword">const</span> in_image_type&amp; in_img,</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        out_image_type&amp; out_img,</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP1&gt;&amp; row_filter,</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keyword">const</span> matrix_exp&lt;EXP2&gt;&amp; col_filter,</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;        T scale = 1,</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        <span class="keywordtype">bool</span> use_abs = <span class="keyword">false</span>,</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="keywordtype">bool</span> add_to = <span class="keyword">false</span></div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    );</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160; </div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        <span class="keywordtype">long</span> NR,</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        <span class="keywordtype">long</span> NC,</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <span class="keyword">typename</span> U,</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        <span class="keyword">typename</span> in_image_type</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        &gt;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> separable_3x3_filter_block_grayscale (</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        T (&amp;block)[NR][NC],</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        <span class="keyword">const</span> in_image_type&amp; img,</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span>&amp; r,</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span>&amp; c,</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        <span class="keyword">const</span> U&amp; fe1, </div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        <span class="keyword">const</span> U&amp; fm,  </div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="keyword">const</span> U&amp; fe2 </div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    );</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160; </div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="keywordtype">long</span> NR,</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        <span class="keywordtype">long</span> NC,</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        <span class="keyword">typename</span> T,</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        <span class="keyword">typename</span> U,</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        <span class="keyword">typename</span> in_image_type</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        &gt;</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> separable_3x3_filter_block_rgb (</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        T (&amp;block)[NR][NC],</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        <span class="keyword">const</span> in_image_type&amp; img,</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span>&amp; r,</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span>&amp; c,</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        <span class="keyword">const</span> U&amp; fe1, </div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        <span class="keyword">const</span> U&amp; fm, </div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        <span class="keyword">const</span> U&amp; fe2</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    );</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160; </div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">double</span> gaussian (</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        <span class="keywordtype">double</span> x, </div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        <span class="keywordtype">double</span> sigma</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    );</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160; </div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;        &gt;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    matrix&lt;T,0,1&gt; create_gaussian_filter (</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        <span class="keywordtype">double</span> sigma,</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;        <span class="keywordtype">int</span> size </div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;    );</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160; </div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        <span class="keyword">typename</span> in_image_type,</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        <span class="keyword">typename</span> out_image_type</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;        &gt;</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    rectangle gaussian_blur (</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;        <span class="keyword">const</span> in_image_type&amp; in_img,</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;        out_image_type&amp; out_img,</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;        <span class="keywordtype">double</span> sigma = 1,</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;        <span class="keywordtype">int</span> max_size = 1001</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;    );</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160; </div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;        <span class="keyword">typename</span> image_type1, </div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;        <span class="keyword">typename</span> image_type2</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;        &gt;</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;    <span class="keywordtype">void</span> sum_filter (</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;        <span class="keyword">const</span> image_type1&amp; img,</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;        image_type2&amp; out,</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;        <span class="keyword">const</span> rectangle&amp; rect</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;    );</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160; </div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;        <span class="keyword">typename</span> image_type1, </div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;        <span class="keyword">typename</span> image_type2</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;        &gt;</div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;    <span class="keywordtype">void</span> sum_filter_assign (</div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;        <span class="keyword">const</span> image_type1&amp; img,</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;        image_type2&amp; out,</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;        <span class="keyword">const</span> rectangle&amp; rect</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;    );</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160; </div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;        <span class="keyword">typename</span> image_type1, </div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;        <span class="keyword">typename</span> image_type2</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;        &gt;</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;    <span class="keywordtype">void</span> max_filter (</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;        image_type1&amp; img,</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;        image_type2&amp; out,</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span> width,</div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;        <span class="keyword">const</span> <span class="keywordtype">long</span> height,</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;        <span class="keyword">const</span> <span class="keyword">typename</span> image_traits&lt;image_type1&gt;::pixel_type&amp; thresh</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;    );</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160; </div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;}</div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160; </div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;<span class="preprocessor">#endif // DLIB_SPATIAL_FILTERINg_ABSTRACT_</span></div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
